
/*!
*************************************************************************************
* \file  mfc_dec.c
*
* \brief 
*        MFC SDK  decoder layer interface to JM decoder
*
* \author 
*    Main contributors
*        - Hariharan Ganapathy   (hari.ganapathy@dolby.com)
*
*
*************************************************************************************
*/


#include "c3d_decoder_layer_api.h"
#include "c3d_utilities_api.h"
#include "mfc_dec.h"


void* allocate_mfc_decoder_wrapper(){          
    
   
    return(allocate_mfc_decoder_layer());

}

int initialize_mfc_decoder_wrapper(void *pv_dec_lyr_ctxt,void  *init_params){            

    return(initialize_mfc_decoder_layer(pv_dec_lyr_ctxt,(RPUData *)init_params));

}

  int processDecRpuWrapper(
                        void    *pv_dec_layer_context,
                const    void    *pv_recon_bl,
                        void    *pv_pred_el                        
                        )
{
    int status = 0;


    status = process_dec_rpu(pv_dec_layer_context,
                        (ImageData *)pv_recon_bl,                                             
                        (ImageData *)pv_pred_el                                                
                        );



                    
     
    return status;

}
    
int   process3DDeMuxWrapper(void    *pv_dec_layer_context,
                            void    *pv_view0_image,
                            void    *pv_view1_image,
                    const    void   *pv_bl_image,
                    const    void   *pv_el_image,                        
                    const    void   *pv_predel_image,
                              int     deMuxMode,
                              int     rpu_field_processing
                        )
{

    ImageData p_v0 ;
    ImageData p_v1 ;
    ImageData p_bl;
    ImageData p_el;
    ImageData p_pel;
    int i32_loop;
    int status = 0;

    for(i32_loop=rpu_field_processing;i32_loop<2*rpu_field_processing+ 1;i32_loop++)
    {


            /* Setup Image Format for Input/Output Images */
            change_image_format(&p_v0        ,(ImageData *)pv_view0_image        ,(PICTURE_TYPE)i32_loop);
            change_image_format(&p_v1        ,(ImageData *)pv_view1_image        ,(PICTURE_TYPE)i32_loop);
            change_image_format(&p_bl        ,(ImageData *)pv_bl_image            ,(PICTURE_TYPE)i32_loop);
            change_image_format(&p_el        ,(ImageData *)pv_el_image            ,(PICTURE_TYPE)i32_loop);
            change_image_format(&p_pel        ,(ImageData *)pv_predel_image        ,(PICTURE_TYPE)i32_loop);



            if(deMuxMode==1)
            {
                status = process3DDeMux_OM(pv_dec_layer_context,
                                    &p_v0,
                                    &p_v1,
                                    &p_bl,
                                    &p_el,
                                    &p_pel
                                    );
            }
            else
            {
                    status = process3DDeMux_FC(pv_dec_layer_context,
                                    &p_v0,
                                    &p_v1,
                                    &p_bl
                                    );                
            }

    }

     
    return status;

}


int32_t free_mfc_decoder_wrapper(void  *pv_dec_layer_ctxt){        
    
    free_mfc_decoder_layer(pv_dec_layer_ctxt);       


    return 0;

}





