
/*!
*************************************************************************************
* \file  c3d_mux_filters.h
*
* \brief 
*
*
* \author 
*    Main contributors
*        - Hariharan Ganapathy   (hgana@dolby.com)
*
*
*************************************************************************************
*/


#ifndef _C3D_MUX_FILTERS_
#define _C3D_MUX_FILTERS_


#define MAX_NUM_MUX_FILTER_TAPS 25


/** 1D Muxing filter definition */
const int16_t ai16_1D_muxing_coef[TOTAL_NUM_OF_DOWNSAMPLE_MUX_FILTER][MAX_NUM_MUX_FILTER_TAPS] = {
  /* SVC3D */ {2, 0,-4, -3 , 5 , 19, 26, 19, 5, -3, -4, 0, 2},
  /* FC_P44 */ {30, -4,-61,-21, 83, 71,-102,-178, 116, 638,904,638,116,-178,-102,71,83,-21,-61,-4,30}, 
};

/** 
 * Filter length, offset and dynamic range of 1D muxing horizontal filters. 
 */

const uint16_t au16_1D_muxing_filter_length[TOTAL_NUM_OF_DOWNSAMPLE_MUX_FILTER] = {
  /* SVC3D */ 13,
  /* FC_P44 */ 21,
};

const uint16_t au16_1D_muxing_filter_dynamic_range[TOTAL_NUM_OF_DOWNSAMPLE_MUX_FILTER] = {
  /* SVC3D */ 6,
  /* FC_P44 */ 11,
};

const uint16_t au16_1D_muxing_filter_offset[TOTAL_NUM_OF_DOWNSAMPLE_MUX_FILTER] = {
  /* SVC3D */ 32,
  /* FC_P44 */ 1024,
};



#endif /* _C3D_MUX_FILTERS_ */
