
/*!
*************************************************************************************
* \file  c3d_rpu_kernel_pvt.h
*
* \brief 
*        MFC SDK  RPU internal structures
*
* \author 
*    Main contributors
*        - Hariharan Ganapathy   (hari.ganapathy@dolby.com)
*
*
*************************************************************************************
*/


#ifndef _C3D_RPU_KERNEL_PVT_H_
#define _C3D_RPU_KERNEL_PVT_H_

/** ENUMERATIONS */

/** SBS_VIEW */
typedef enum sbs_view
{
    LEFT = 0,
    RIGHT
} SBS_VIEW;

/** OU_VIEW */
typedef enum ou_view
{
    TOP = 0,
    BOTTOM
} OU_VIEW;

/** STRUCTURES */

/**
 * RPU Handle
 * This is the handle to the RPU. It contains pointers to RPU filters.
 */
typedef struct rpu_handle
{
    /*
     * Array of filters
     * Depending upon the RPU process format, the corresponding SBS or OU implicit filters 
     * are initialized at init.  Used by OM Up Filters .
     */
    RPUFilter    rpu_om_up_filter;

    /*
     * Array of filters for OM Down filters are initialized at init.
     */
    RPUFilter    rpu_om_down_filter;

    /* Image buffer pointer that is used to store the intermediate result in 2D separable filtering. */
    ImageData    *p_temp_img;

} RPUHandle;

#endif /* _C3D_RPU_KERNEL_PVT_H_ */
