
/*!
*************************************************************************************
* \file  c3d_rpu_kernel_utils.h
*
* \brief 
*
*
* \author 
*    Main contributors
*        - Hariharan Ganapathy   (hari.ganapathy@dolby.com)
*
*
*************************************************************************************
*/



#ifndef _C3D_RPU_KERNEL_UTILS_H_
#define _C3D_RPU_KERNEL_UTILS_H_

/** FUNCTION MACROS */

/** Absolute value */
#define ABS_VAL(a)                  (((a) >= 0) ? (a) : -(a))

/**
 * The function macro shifts the input right by val.
 * Right shift by a negative integer is interpreted as left shift by its absolute value.
 */
#define SHIFT_RIGHT(in, shift)      ((shift) >= 0 ? ((in) >> (shift)) : ((in) << ABS_VAL(shift)))


/** The greater of two numbers */
#define MAX_VAL(a, b)               (((a) > (b)) ? (a) : (b))

/** The smaller of two numbers */
#define MIN_VAL(a, b)               (((a) < (b)) ? (a) : (b))

/* clip 16-bit signed input to 8-bit unsigned value */
#define CLIP(x)                     (MIN_VAL((MAX_VAL((x), (0))), (255)))
/*#define CLIP(x)                   u8ClipTable[(uint16_t)x] */

/* add offset and shift right */
#define OFFSET_SHIFT_RIGHT(x, o, a) (((x) +(o))>> (a))




#endif /* _C3D_RPU_KERNEL_UTILS_H_ */
